# coding: utf-8

"""
    REST API

    Rockset's REST API allows for creating and managing all resources in Rockset. Each supported endpoint is documented below.  All requests must be authorized with a Rockset API key, which can be created in the [Rockset console](https://console.rockset.com). The API key must be provided as `ApiKey <api_key>` in the `Authorization` request header. For example: ``` Authorization: ApiKey aB35kDjg93J5nsf4GjwMeErAVd832F7ad4vhsW1S02kfZiab42sTsfW5Sxt25asT ```  All endpoints are only accessible via https.  Build something awesome!  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from rockset.swagger_client.models.status_az_service_bus import StatusAzServiceBus  # noqa: F401,E501


class SourceAzServiceBus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'topic': 'str',
        'subscription': 'str',
        'status': 'StatusAzServiceBus'
    }

    attribute_map = {
        'topic': 'topic',
        'subscription': 'subscription',
        'status': 'status'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """SourceAzServiceBus - a model defined in Swagger"""  # noqa: E501

        self._topic = None
        self._subscription = None
        self._status = None
        self.discriminator = None

        self.topic = kwargs.pop('topic', None)
        self.subscription = kwargs.pop('subscription', None)
        self.status = kwargs.pop('status', None)

    @property
    def topic(self):
        """Gets the topic of this SourceAzServiceBus.  # noqa: E501

        name of the topic which rockset should ingest from  # noqa: E501

        :return: The topic of this SourceAzServiceBus.  # noqa: E501
        :rtype: str
        """
        return self._topic

    @topic.setter
    def topic(self, topic):
        """Sets the topic of this SourceAzServiceBus.

        name of the topic which rockset should ingest from  # noqa: E501

        :param topic: The topic of this SourceAzServiceBus.  # noqa: E501
        :type: str
        """

        self._topic = topic

    @property
    def subscription(self):
        """Gets the subscription of this SourceAzServiceBus.  # noqa: E501

        the subscription to read from the topic  # noqa: E501

        :return: The subscription of this SourceAzServiceBus.  # noqa: E501
        :rtype: str
        """
        return self._subscription

    @subscription.setter
    def subscription(self, subscription):
        """Sets the subscription of this SourceAzServiceBus.

        the subscription to read from the topic  # noqa: E501

        :param subscription: The subscription of this SourceAzServiceBus.  # noqa: E501
        :type: str
        """

        self._subscription = subscription

    @property
    def status(self):
        """Gets the status of this SourceAzServiceBus.  # noqa: E501

        Azure Service bus source status  # noqa: E501

        :return: The status of this SourceAzServiceBus.  # noqa: E501
        :rtype: StatusAzServiceBus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this SourceAzServiceBus.

        Azure Service bus source status  # noqa: E501

        :param status: The status of this SourceAzServiceBus.  # noqa: E501
        :type: StatusAzServiceBus
        """

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SourceAzServiceBus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SourceAzServiceBus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

    def __getitem__(self, item):
        return getattr(self, item)

    def get(self, item):
        return getattr(self, item)

    def items(self):
        return self.to_dict().items()

    def __setitem__(self, item, value):
        return seattr(self, item, value)
